package com.massa.mrules.demos.eshop.custom;

import java.io.IOException;
import java.util.Collection;

import com.massa.mrules.accessor.AbstractReadAccessor;
import com.massa.mrules.addon.IAddonsManager;
import com.massa.mrules.addon.MAddonsFinder;
import com.massa.mrules.context.IContext;
import com.massa.mrules.context.compile.ICompilationContext;
import com.massa.mrules.context.execute.IExecutionContext;
import com.massa.mrules.exception.MAccessorException;
import com.massa.mrules.exception.MConfigurationException;
import com.massa.mrules.exception.MRuleInternalException;
import com.massa.mrules.exception.MRuleValidationException;
import com.massa.mrules.util.CostInfo;
import com.massa.mrules.util.OuterWithLevel;

public class EshopAddonsManager implements IAddonsManager {

	public EshopAddonsManager() {
	}

	public void registerAddons() throws MConfigurationException, MRuleInternalException {
		MAddonsFinder.registerAddon(new EshopAddonsManager.DiscountGenerator());
	}

	public static class DiscountGenerator extends AbstractReadAccessor {

		private static final long serialVersionUID = 1L;
		private static int idx = 0;

		@Override
		public void compileValue(ICompilationContext ctxt, Class<?> expectedType)
				throws MRuleValidationException {
		}

		@Override
		public <G, C extends Collection<G>> void compileCollection(
				ICompilationContext ctxt, Class<C> expectedType,
				Class<G> expectedGenericType) throws MRuleValidationException {
		}

		public Object get(final IExecutionContext ctxt) throws MAccessorException {
			//Here should be placed the implementation of a real discount code generator.
			return "GENERATED_DISCOUNT" + (++idx);
		}

		public String getImplementationId() {
			return "DISCOUNTGEN";
		}

		public Class<?> getType(final IContext ctxt) throws MAccessorException {
			return String.class;
		}

		/**
		 * Returns false, as generator should always be called.
		 */
		public boolean isCacheUsed() {
			return false;
		}

		public CostInfo getEstimatedReadCost(ICompilationContext ctxt)
				throws MRuleValidationException {
			return new CostInfo(1);
		}

		public boolean isShouldIterate() {
			return false;
		}

		public Class<?> getGenericCollectionType(IContext ctxt)
				throws MAccessorException {
			return null;
		}

		public void toString(OuterWithLevel outer) throws IOException {
			outer.write(this.getImplementationId());
		}

		@Override
		public boolean equals(final Object o) {
			return o != null && this.getClass() == o.getClass();
		}

		@Override
		public int hashCode() {
			return this.getClass().hashCode();
		}
	}
}
